; Disassembly of the 2048-byte file "Space Invaders (proto).bin"
; Early PROTOTYPE version missing some sounds, animated explosions,
; and UFO onscreen score.  Fits into a 2K EPROM completely though.
;
; Note: other differences in released version are a Black background,
; Interrupt Routines to change COL1R and COL3R four times per screen,
; SENTRY / DOIT routines with TIMeOUT (only for the GAME OVER period)
; and shorter Invaders so they no longer overlap and flicker so bad.
;
; > Thanks to Paul for dumping Bill Juns <dashopepper1> 's cartridge,
; > as seen in the video "Space Invaders (Demo) for Bally Astrocade"
; > by JUNScoPICTURES at: http://www.youtube.com/watch?v=V3rWANP2aRg
; >
; > Lance, was this really given Videocade number #2008 pre-release?
; >
;
; CPU Type: Z80 for the Bally (aka Astrocade) Home Library Computer
; 
; Using the opcode map file "DZ80-INI.MAP" created with dZ80 2.0,
; and using scripts "BallyHVG.LUA" and "NOTE1.LUA" by Richard Degler
; 
; on Saturday, 07 of June 2014 at 05:56 AM by Richard C. Degler
; As always - assemble this file into a source code using simply
; ZMAC -i -m "Space Invaders (proto).asm" (or DOSname SPACEI~1.ASM)
;
; Comments are borrowed heavily from final "battle.asm" as follows :
;
; ; Astro Battle - Videocade #2009
; ; For Bally/Astrocade
; ;
; ; Disassembly begun Aug. 1, 2011 by Adam Trionfo
; ;
; ; Release History:
; ; ----------------
; ;    Release .05 (Aug. 15, 2011) (All changes by R.C.D. on Aug. 13, 2011)
; ;       - Remaining RAM cells identified.
; ;       - MANY comments added
; ;       - TODO:
; ;            - Check out the actual UFO Bonus scoring, and
; ;              the logic for launching one!
; ;            - Try to figure out the 3 "Invader Delay"s and why the 4th
; ;              "Invader's Shot Vector Block" is handled differently
; ;              from the other three using L2589: ?
; ;            - Also add "off" at the end of "; No Keys are Masked" since
; ;              they have ALL been masked "on", meaning that "None have
; ;              been masked inactive",  I say.
; ;    Release .04 (Aug. 11, 2011)
; ;       - MANY Comments and explanations added by R.C.D.
; ;       - Corrections to Music Score (concerning PUSHN) added by
; ;         Adam Trionfo (at the recommendation of R.C.D.)
; ;    Release .03 (Aug. 9, 2011)
; ;       - Commented Music Scores
; ;    Release .02 (August 9, 2011) (All changes by R.C.D. on Aug. 6, 2011)
; ;       - Vector Blocks identified
; ;       - Some comments added
; ;       -  Straightened out some columns.
; ;    Release .01 (August 5, 2011)
; ;       - VERY Preliminary Release-- Released so that those who
; ;         are curious can take a look.
; ;
; ; I disassembled this game using time, effort and the following
; ; tools and materials:
; ;    1. Beyond Compare 3
; ;    2. DZ80 Disassembler (with BallyHVG.LUA disassembly script [by R.C.D.])
; ;    3. FC (File Compare) Command on Windows XP Command Line
; ;    4. "How to Program the Z80," Third Edition, By Rodnay Zaks
; ;    5. HVGLIB.H - Home Video Game Library header file
; ;    6. MESS Astrocade Emulator
; ;    7. "Home Video Game Manual for the Bally Astrocade"
; ;       (aka "Nutting" Manual) and Bally On-Board ROM Source Code
; ;    8. PS Pad (Text Editor which creates a sort of IDE for ZMac)
; ;    9. Windows XP Built-In Scientific Calculator
; ;    10. ZMac Assembler 1.3 (Windows 32 Version)
; ;
; ; Lastly, but just as important as the rest, was that the disassembly
; ; work was accompanied by Beethoven's Symphonies 1-9.  That is five
; ; hours and forty minutes of music that I listened to over and over
; ; while wading through the 3.2K of code and data.
;

        NOLIST
        INCLUDE "HVGLIB.H"      ; Home Video Game Library

; System ROM locations
SYSROM  EQU     $0000           ; Start of On-Board 8K System ROM
GUNSHOT EQU     $1885           ; Play On-Board musicScore GUNSHOT

; RAM that is initialized at Program startup
; $4E10 for 13-byte "Player's Shot" Vector Block
; $4E1D for "Invader's Shot" Vector Block #1
; $4E2A for "Invader's Shot" Vector Block #2
; $4E37 for "Invader's Shot" Vector Block #3

; PLAYERX EQU     $4E44           ; init to 8 for Player X Position (0 to 148)
; $4E45 set to 2 for Invader Explosion, 40 for Player Explosion down-Counter
; $4E46 temp word Invader Explosion XY position
; $4E48 byte for Player Shot Off or On (0 or 82)

; Invader's 6-byte IX block [Upper-Left corner]
; $4E49 init to 3 for Invader Field X Left side
; $4E4A each new Wave x8 for Field Y Top
; $4E4B [not used ??]
; $4E4C byte current Row being Drawn Y Top
; $4E4D for Which Invader Row being Drawn
; $4E4E ?? Right Edge ?? IX+$05 0 to 3 [7 ??]

; Live Invaders 4 Row array of 8 bits per Row
; note: MS bit is Left Invader; LS is Right one
; $4E4F-$4E52 init to 11111111B's for 32 bits of 1's

; $4E53 init to 1 for Invader Delta X (+1 or -1)
; $4E54 temp byte ?? Temp ?? [?? Row Y of Shot Invader ??]

; Edge Limit 2-byte IY block [compare to Field X Left side]
; [note: computed based on Invader's Footprint quite often]
; $4E55 init to 1 for ?? Right edge Limit [may be reversed ??]
; $4E56 init to 32 for ?? Left edge Limit [can go negative]

; $4E57 [not used ??]
; $4E58 store Live Invader's Footprint [Live Invaders Array overlapped into one byte ??]
; $4E59 init to 80 for Invader Delay A [the lower these go, the faster the Invaders march ??]
; $4E5A init to 80 for Invader Delay B
; $4E5B init to 80 for Invader Delay C
; $4E5C HeartBeep 2.133-second Delay downcounter
; $4E5D for UFO Delta X [0 or reverse of Invader Delta X]
; $4E5E for UFO X Position (1 to 150)

SCORE   EQU   $4E5F     ; Player's Score (2 Bytes, BCD) Max Score is 9999

; $4E61   init to 1 for first Wave up-Counter byte x8 for $4E4A

LIVES   EQU   $4E62     ; init to $03 Number of Player Bases (or "Lives")

; $4E63 init 0 for Extra Base Flag
; $4E64 init 0 [then not used ??]

; GAMDIF  EQU     $4E65           ; GAMe DIFficulty Setting

STACKPT EQU     $4F06           ; System STACK Pointer Top

; MUSSTK  EQU     $4F12           ; MUSicSTacKtop !!

; System RAM locations
; CT0 byte Wait 2 for Next Invader Shot ??
; CT3 byte Wait for 25 guesstimated Music Score time
; [TIMOUT, CT1, CT2, CT4-CT7 not used]
;

        LIST
        ORG     FIRSTC          ; FIRST address in Cartridge

        DB      "U"             ; User Cartridge Sentinel

; On-Board-ROM Menu Data Structure
        DW      MENUST          ; Link to Head of On-Board MENU STart
        DW      L27E3           ; Address of GAME TITLE menu text
        DW      L2007           ; Jump here if "SPACE INVADERS" selected

L2007:  SYSSUK  GETPAR          ; UPI GET game PARameter from user
        DW      L27FA           ; ... Prompt Address = 10234 for "LEVEL"
        DB      $81             ; ... Digits = 129
        DW      $4E65           ; ... Parameter Address = 20069 [ON-SCREEN !!]
        ;
        LD      SP,STACKPT      ; load $4F06 as StackPointer top
;
; Setup 8 Color Registers
; -----------------------
; Use Port $0B (COLBX, write COLor BloCK multi-port) to
; setup the eight Color Registers [instead of SYSTEM COLSET ??].
; (See "DNA Manual" Page 88 has more information)
        LD      HL,L27F2
        LD      B,$08
        LD      C,COLBX
        OTIR                    ; outport 8 bytes of COLor TABle to COLorBloX
;
; Setup Vertical Blank line
; -------------------------
;   Make room for stack, variables, tables, etc. in the scratchpad
;   (hidden) area at the bottom of the screen.  The total possible
;   vertical resolution is 102.  Only 90 lines will be displayed.
;   RAM Setup works out to:
;
;      $4000-$4E0F -  3,600 Bytes (90 Lines)
;      $4E10-$4FFF -  496 Bytes (12 lines + 16 Scratchpad Bytes)
;
;   (See "DNA Manual" Pages 85 and 90 has more information)
        LD      A,$B4
        OUT     (VERBL),A       ; outport &(10)=180 for VERtical Blanking Line 90
;
; Set Horizontal Color Boundary and Background Color
; --------------------------------------------------
;   Horizontal Color Boundary (Bits 0-5 of Port $09)
;   Background Color (Bits 6 and 7 of Port $09)
;   (See "DNA Manual" Pages 88-89 has more information)
        LD      A,$80           ; 10000000B for Color 2 and 0 for all Right colors
        OUT     (HORCB),A       ; outport &(9)=128 for HORizontal Color Boundary
;
; Initialize 7 Bytes in Scratchpad Area:
; --------------------------------------
;    Set Initial Number of Bases (or "lives")
        LD      A,$03
        LD      ($4E62),A       ; preset LIVES to 3 for Initial Number of Bases
        LD      A,$01
        LD      ($4E61),A       ; preset Wave Counter to 1
        LD      HL,$0000
        LD      ($4E5F),HL      ; Initial Player SCORE word is zero points 
        LD      ($4E63),HL      ; Initialize Extra Base flag and ?? to 0
;
; Clear Screen and Beginning of Scratchpad from $4000 start to $4E5D
; ----------------------------------------
; loop here when all 32 Invaders destroyed
L2035:  SYSSUK  FILL            ; UPI FILL memory with data
        DW      NORMEM          ; ... Memory Address = 16384
        DW      $0E5E           ; ... Byte Count = 3678
        DB      $00             ; ... Data = 0
        ;
; Initialize Scratch RAM
; ----------------------
;   This loops to initialize 4 Vector Blocks of 13 bytes each.
;   When the loop is complete, scratchpad will look like this:
;
;   Vector IX Base  +$02   +$07   +$09   +$0C
;   Block    =$20    =$01   =$01   =$02   =$01
;   ------  ------  -----  -----  ----- ------
;    #1     $4E10,  $4E12, $4E17, $4E19, $4E1C
;    #2     $4E1D,  $4E1F, $4E24, $4E26, $4E29
;    #3     $4E2A,  $4E2C, $4E31, $4E33, $4E36
;    #4     $4E37,  $4E39, $4E3E, $4E40, $4E43
;
; "Looks like 3 shots at a time for the Aliens and 1 for the Player!" R.D.
;
        LD      B,$04           ; for 4 Vector Blocks
        LD      DE,$000D        ; 13 for IndeX quantum
        LD      IX,$4E10        ; index Player 1 VectorBlock first
L2045:  LD      (IX+$00),$20    ; preset VB Magic Register to X-OR draw/erase
        LD      (IX+$02),$01    ; preset VB TIMeBase to NO division
        LD      (IX+$07),$01    ; preset VB XCHK to VBCLMT bit (not used ??)
        LD      (IX+$09),$02    ; preset VB Delta Y High to 2 pixel speed
        LD      (IX+$0C),$01    ; preset VB YCHK bit 0 to Check Y LiMiTs
        ADD     IX,DE
        DJNZ    L2045                   ; (-$18) to next Vector Block
;
; Initialize 7 Bytes in Scratchpad Area
; -------------------------------------
        LD      A,$01
        LD      ($4E53),A       ; preset Invader Delta X to 1 (going Right)
        LD      ($4E55),A       ; preset Right Limit to 1 [should be $22 ??]
        LD      HL,$FC80
        LD      ($4E18),HL      ; preset VECTORB + VBDY word to -3.5 for Y Speed
        LD      A,$08
        LD      ($4E44),A       ; preset PLAYERX to 8 for X Position 
        LD      A,$1E
        LD      ($4E56),A       ; preset Left Limit to 30 [should be 0 ??]
        LD      A,$03
        LD      ($4E49),A       ; preset Invader Field X Left to 3
;
; Initialize $4E4F-$4E52 to $FF [populate 4 rows of 8 Invaders each]
; ----------------------------
        LD      B,$04           ; Setup Loop to run 4 times
        LD      HL,$4E4F        ; Setup First byte to Initialize to $FF
L207F:  LD      (HL),$FF        ; Initialize 1 byte of Scratchpad to -1
        INC     HL              ; Increment Scratchpad Byte by 1
        DJNZ    L207F                   ; (-$05) to run 4 times
;
; current Wave x8 pixels to lower Invaders' starting position
        LD      A,($4E61)       ; read Wave Counter
        SLA     A               ; times 8
        SLA     A
        SLA     A
        LD      ($4E4A),A       ; Initialize Invader Field Y Top
        LD      A,($4E61)       ; read ?? again
        INC     A               ; plus 1
        LD      ($4E61),A       ; bump up Wave Counter
;
; Write Four Player "Protective Bunkers"
; ---------------------------------------
;   The Four Bunker's X,Y Coordinate's are:
;      Bunker 1 (Left-Most):    10, 65
;      Bunker 2 (Middle-Left):  50, 65
;      Bunker 3 (Middle-Right): 90, 65
;      Bunker 4 (Right-Most):  130, 65
;
        LD      B,$04           ; 4 for 4 writes
        LD      E,$0A           ; 10 for LEFTmost X
L209B:  LD      HL,L26BE        ; point at Player's BUNKER
        XOR     A               ; Magic Register = 0 for PLOP
        LD      D,$41           ; 65 for all Y Coordinate's
        PUSH    DE              ; store DE for X Coordinate
        PUSH    BC
        SYSTEM  WRITP           ; UPI WRITe with Pattern size lookup
        ;
        POP     BC
        POP     DE              ; restore DE for X Coordinate
        LD      A,E             ; old X + 40
        ADD     A,$28
        LD      E,A             ; X Coordinate for Next Bunker
        DJNZ    L209B                   ; (-$12) to run 4 times
;
; Restore CALL L26AB and remove jump [?? note from ??]
        SYSSUK  STRDIS          ; UPI STRing DISplay "BASES"
        DB      $08             ; ... X = 8
        DB      $00             ; ... Y = 0
        DB      $1C             ; ... Options = 28
        DW      L2688           ; ... String Address = 9864
        ;
        CALL    L246B
        SYSSUK  STRDIS          ; UPI STRing DISplay "SCORE"
        DB      $50             ; ... X = 80
        DB      $00             ; ... Y = 0
        DB      $1C             ; ... Options = 28
        DW      L268E           ; ... String Address = 9870
        ;
        CALL    L23C6           ; do SHOW current POINTS
;
; Write 4 Rows of Invaders
; ------------------------
        LD      B,$04           ; then 4 times ...
L20C3:  CALL    L2586           ; do DRAW a Row of INVADERs
        PUSH    BC
;
; Delay Loop
;   Pause before writing another row of Invaders.
        SYSSUK  PAWS            ; UPI PAUSE about 1/3 second
        DB      $14             ; ... Interrupts = 20
        ;
        POP     BC              ; done with Pause, so Restore BC
        DJNZ    L20C3                   ; (-$0a) to next loop
        CALL    L2586           ; do DRAW a Row of INVADERs ?? number 5 ??
; enable interrupts for ??
L20D0:  EI
        LD      IY,$4E55        ; point at 2-item Edge Limit array
        LD      A,($4E4D)       ; read Invader Row being Drawn
        CP      $04
        JR      NZ,L20FB                ; (+$1f) skip to do All 4 Rows 
        LD      A,($4E5C)       ; read HeartBeep Delay
        OR      A
        CALL    Z,L2474         ; do PLAY HeartBeep if counted down
        LD      A,($4E49)       ; read Field X Left edge
        LD      B,A
        CP      (IY+$00)        ; $4E55 ?? for Right Limit
        CALL    Z,L248A         ; do Reverse and Drop Invaders if at edge
        LD      A,B
        CP      (IY+$01)        ; $4E56 ?? for Left Limit
        CALL    Z,L248A         ; do Reverse and Drop Invaders if at edge
        LD      A,($4E53)       ; read Invader Delta X [+1 or -1]
        ADD     A,B
        LD      ($4E49),A       ; write new Field X Left
L20FB:  CALL    L2586           ; do DRAW a Row of INVADERs
        XOR     A
        LD      B,$04
        LD      HL,$4E4F        ; point at Live Invaders array
L2104:  OR      (HL)            ; Collapse into one byte...
        INC     HL
        DJNZ    L2104                   ; (-$04)
        LD      C,A             ; ...footprint of Live Invaders
        LD      B,A
        LD      ($4E58),A       ; write to Invader's Footprint
        OR      A
        JP      Z,L2035         ; to Restart on Next Wave if none remaining
; else some more Invaders
        LD      A,$1E           ; Compute Right X edge Limit
L2113:  BIT     0,C             ; test Right Invader bit
        JR      NZ,L211E                ; (+$07) occupied bit found
        ADD     A,$10           ; 30 + 16 for each empty spot
        OR      A               ; [clear CY flag ??]
        SRL     C
        JR      L2113                   ; (-$0b) loop Next bit

L211E:  LD      ($4E55),A       ; write to Right X Limit
        XOR     A               ; Compute Left X edge Limit
L2122:  BIT     7,B             ; test Left Invader bit
        JR      NZ,L212C                ; (+$06) occupied bit found
        SUB     $10             ; 0 - 16 for each empty spot
        SLA     B
        JR      L2122                   ; (-$0a) loop Next bit

L212C:  LD      ($4E56),A       ; write to Left X Limit
        LD      A,($4E5C)       ; count down HeartBeep DELAY
        OR      A
        JR      Z,L2136                 ; (+$01) if Zero already
        DEC     A
L2136:  LD      ($4E5C),A       ; write back HeartBeep DELAY
        LD      A,($4E63)       ; Extra Base flagged already?
        OR      A
        JR      NZ,L2153                ; (+$14)
        LD      HL,($4E5F)      ; Prepare to work on SCORE word
        BIT     4,H             ; 1000 BCD hit?
        JR      Z,L2153                 ; (+$0d)
        LD      A,($4E62)       ; Load ACCUM with Number of Bases
        INC     A               ; Increase [] Bases by 1
        LD      ($4E62),A       ; Award Player Extra Base
        LD      ($4E63),A       ; and write to Extra Base flag
        CALL    L246B           ; do Display "BASES" and bases left on screen
L2153:  LD      A,($4E65)       ; load Accum with Game Difficuly
        CP      $02             ; is the difficulty set to "INTERMEDIATE"?
        JR      C,L2171                 ; (+$17) if "NOVICE" of "AMATEUR"
        JR      Z,L2167                 ; (+$0b) if Yes
        LD      A,($4E5A)       ; else "PROFESSIONAL"
        OR      A
        JR      Z,L2167                 ; (+$05)
        SUB     $04             ; decrease Invader Delay B by 4
        LD      ($4E5A),A
L2167:  LD      A,($4E5B)
        OR      A
        JR      Z,L2171                 ; (+$04)
        DEC     A               ; decrease Invader Delay C by 1
        LD      ($4E5B),A
L2171:  LD      A,($4E59)
        OR      A
        JR      Z,L217C                 ; (+$05)
        SUB     $02             ; decrease Invader Delay A by 2
        LD      ($4E59),A
; skip to here if a Delay decreased
L217C:  LD      A,($4E62)       ; Load Number of Bases into Accum
        OR      A               ; Use OR to set Zero Flag
        JP      Z,L237B         ; break if Number of Bases = 0
        LD      A,(CT0)         ; read $4FD5 for Counter/Timer #0
        OR      A
        JP      NZ,L20D0        ; break if CT0 not counted down
        LD      A,$02
        LD      (CT0),A         ; else write 2 to Counter/Timer #0
        DI
        IN      A,(SW0)         ; inport =&(16) for HANDLE #1
        LD      B,A
        BIT     CHLEFT,A        ; pressed Left ?
        JR      Z,L21A5                 ; (+$0e) if not
        LD      A,($4E44)       ; move Player LEFT -2 to Limit
        CP      $06
        JR      C,L21B5                 ; (+$17) bail if at 6
        DEC     A
        DEC     A
        LD      ($4E44),A       ; write Player X Position - 2
        JR      L21B5                   ; (+$10) moved

L21A5:  BIT     CHRIGH,B        ; pressed Right ?
        JR      Z,L21B5                 ; (+$0c) if not
        LD      A,($4E44)       ; move Player RIGHT +2 to Limit
        CP      $96
        JR      NC,L21B5                ; (+$05) bail if at 150
        INC     A
        INC     A
        LD      ($4E44),A       ; write Player X Position + 2
; check Player FIRE button
L21B5:  BIT     CHTRIG,B        ; if Trigger NOT pulled
        JR      NZ,L21BF                ; (+$06)
        XOR     A
        LD      ($4E48),A       ; set Player's Shot Off ??
        JR      L21E4                   ; (+$25)

L21BF:  LD      A,($4E48)       ; else Trigger pulled
        OR      A
        JR      NZ,L21E4                ; (+$1f)
        LD      A,($4E11)       ; if Player's Shot Y stopped...
        BIT     VBSACT,A
        JR      NZ,L21E4                ; (+$18)
        LD      A,$80           ; ...and VBSTAT not ACTive
        LD      ($4E11),A       ; then turn it on again, and
        LD      A,($4E44)       ; read Player X Position
        ADD     A,$04
        LD      ($4E16),A       ; plus 4 for Player's Shot VBXH
        LD      A,$52
        LD      ($4E48),A       ; 82 for Player Shot On
        LD      ($4E1B),A       ;  and Player's Shot VBYH
        CALL    L2657           ; do Play SHOT Sound (with VIBRAto)
; continue after Trigger test
L21E4:  LD      A,($4E44)       ; read PLAYER X Position
        LD      E,A
        LD      A,$00           ; MAGIC = PLOP
        LD      B,$06
        LD      C,$03
        LD      D,$54           ; Y Coordinate = 84
        LD      HL,L26AC        ; point at 12x6 Player's BASE Pattern
        SYSTEM  WRIT            ; UPI WRITe with sizes provided
        ;
        CALL    L24AE           ; do Blank the Player's Old Shot
        LD      IX,$4E2A
        CALL    L24A3           ; do Erase Invader's Shot #2
        LD      IX,$4E37
        CALL    L24A3           ; do Erase Invader's Shot #3
        LD      HL,$4E5A        ; point at Invader Delay B
        CALL    L24C7           ; do ??
        CALL    L2396           ; do Draw and Check for Collision
        LD      IX,$4E1D
        CALL    L24A3           ; do Erase Invader's Shot #1
        LD      HL,$4E59        ; point at Invader Delay A
        CALL    L24C7           ; do ??
        CALL    L2396           ; do Draw and Check for Collision
        LD      IX,$4E2A        ; point at Invader's Shot VB #2
        BIT     VBSACT,(IX+$01) ; test Vector Block STATus = ACTive?
        JR      NZ,L2235                ; (+$0c)
        LD      A,($4E58)       ; read Invader's Footprint
        OR      A
L222D:  SLA     A
        JR      NC,L222D                ; (-$04)
        OR      A
        JP      Z,L223E
L2235:  LD      HL,$4E5B        ; point at Invader Delay C
        CALL    L24C7           ; do ??
        CALL    L2396           ; do Draw and Check for Collision
; then move Player's Shot
L223E:  LD      IX,$4E10
        LD      HL,L2701        ; LIMIT Table #1 for Player's Shot
        SYSTEM  VECT            ; UPI VECTor move coordinate pair
        ;
        LD      (IX+$02),$01    ; set VBTIMB to NO division for single step 
        BIT     VBCLAT,(IX+$0C) ; Vector Block Y Check, coordinate Limit ATtained ?
        JR      NZ,L225A                ; (+$09) if Shot reached Top of Screen
        BIT     VBSACT,(IX+$01) ; else test Vector Block STATus = ACTive?
        JP      Z,L234E         ; to skip if Not moving
        JR      L22A9                   ; (+$4f) else to continue...

; Player's Shot [always ??] made Contact [or Hit the Top]
L225A:  LD      (IX+$01),$00    ; clear $4E11's ?? VBSTATus byte
        LD      A,$01
        LD      ($4E1C),A       ; reset Player's Shot VBYCHK to VBCLMT
        LD      A,$02
        LD      ($4E45),A       ; write 2 to Invader Explosion counter
        LD      A,($4E16)       ; read Player's Shot VB X High
        LD      E,A
        LD      A,($4E1B)       ; read Player's Shot VB Y High
        LD      D,A
        LD      ($4E46),DE      ; write word to Explosion XY position
        LD      A,($4E5D)       ; read UFO Delta X
        OR      A
        JP      Z,L234E         ; skip if UFO NOT moving ?
        LD      A,($4E5E)       ; else read UFO X Position
        NEG
        ADD     A,E
        JP      M,L234E         ; to skip if UFO is LEFT of Player's Shot X ?
        CP      $0E
        JP      NC,L234E        ; to skip if RIGHT of Player's Shot X + 14 ?
        LD      A,D
        CP      $0C
        JP      NC,L234E        ; to skip if Player's Shot Y is BELOW line 12 ?
        CALL    L241D           ; do Erase UFO
        SYSSUK  RANGED          ; UPI RANGED random number
        DB      $03             ; ... Cutoff = 3
        ;
        INC     A               ; now 1 to 3 Bonus for BCD Hundreds digit
        LD      HL,($4E5F)      ; Prepare to work with Player's SCORE word
        ADD     A,H             ; Add High Byte of Score to Accum
        OR      A
        DAA                     ; Decimal Adjust Accumulator
        LD      H,A
        LD      ($4E5F),HL      ; write SCORE word
        CALL    GUNSHOT         ; do ON-BOARD Play GUNSHOT
        CALL    L23C6           ; do SHOW new POINTS
        JP      L234E           ; to skip ??

; ...continue ??
L22A9:  IN      A,(INTST)       ; inport =&(8) to CLEAR INTercept STatus
        CALL    L249B           ; do DRAW the Player Shot
        IN      A,(INTST)       ; then =&(8) again to CHECK INTercept STatus
        OR      A
        JP      Z,L234E         ; to skip if NO Overlap found
        CALL    L24AE           ; do Blank the Player's Old Shot 
        LD      A,($4E16)
        LD      E,A             ; X Coordinate for UL corner of Rectangle
        LD      A,($4E1B)
        LD      D,A             ; Y Coordinate for UL corner of Rectangle
        LD      C,$04           ; Erase a 4 by 4 BLOCK
        LD      B,$04
        LD      A,$00
        SYSTEM  RECTAN          ; UPI paint a RECTANgle
        ;
        LD      IX,$4E10
        LD      A,($4E4A)       ; read current Field Y Top
        LD      H,A
        ADD     A,$1D
        LD      L,A
        LD      E,$04
        LD      C,(IX+$06)      ; read VBXH for X Location
        LD      D,(IX+$0B)      ; read VBYH for Y Location
        LD      IY,$4E4F        ; point at Live Invaders array
L22DE:  LD      A,H
        NEG
        ADD     A,D
        CP      $08
        JR      C,L22F5                 ; (+$0f)
        INC     IY              ; Next ??
        DEC     E               ; ?? Row
        LD      B,$08
L22EB:  INC     H               ; H = H + 8 loop [why a loop ??]
        DJNZ    L22EB                   ; (-$03)
        LD      A,H
        CP      L
        JP      NC,L225A        ; to Player's Shot Collided ?? if ??
        JR      L22DE                   ; (-$17) to loop ??

L22F5:  LD      A,H
        LD      ($4E54),A       ; save ?? Temp
        LD      L,E
        LD      A,($4E49)       ; read Field X Left
        LD      H,A
        LD      E,10000000B     ; $80 for Left Invader bit
L2300:  LD      A,H
        NEG
        ADD     A,C
        CP      $0E
        JR      C,L2318                 ; (+$10)
        OR      A
        JP      C,L225A         ; to Player's Shot Collided ?? if ??
        LD      B,$10
L230E:  INC     H               ; H = H + 16 loop [why a loop ??]
        DJNZ    L230E                   ; (-$03)
        SRL     E
        JP      C,L225A         ; to Player's Shot Collided ?? if ??
        JR      L2300                   ; (-$18) to loop

L2318:  LD      A,E             ; ?? Mask out Dead Invader here ??
        CPL
        AND     (IY+$00)
        LD      (IY+$00),A
        LD      A,($4E54)       ; un-save ?? Temp
        LD      D,A
        LD      E,H
        SLA     L               ; ?? times 16 for Points
        SLA     L
        SLA     L
        SLA     L
        LD      H,$00
        LD      BC,($4E5F)      ; read SCORE word
        ADD     HL,BC
        LD      A,L
        OR      A               ; [clear CY flag]
        DAA                     ; Decimal Adjust Accumulator
        LD      L,A
        LD      A,$00
        ADC     A,H
        DAA                     ; Decimal Adjust Accumulator
        LD      H,A
        LD      ($4E5F),HL      ; write SCORE word
        LD      B,$09           ; erase old (9 x 12) POINT value
        LD      C,$0C
        LD      A,$00           ; Color Mask to Write Rectangle with
        SYSTEM  RECTAN          ; UPI paint a RECTANgle
        ;
        CALL    L23C6           ; do SHOW new POINTS
        JP      L225A           ; to Player's Shot Collided ??

; ?? skips here a lot ??
L234E:  LD      A,($4E4A)       ; read current Field Y Top
        CP      $12
        CALL    NC,L23CF        ; do MAYBE Launch UFO if Field NOT too high
        CALL    L254D           ; do Explosion routine
        LD      B,$04
        LD      C,$00
        LD      IY,$4E4F        ; point at Live Invaders array
L2361:  LD      A,(IY+$00)
        OR      A
        JR      Z,L236C                 ; (+$05)
        INC     IY
        INC     C
        DJNZ    L2361                   ; (-$0b)
L236C:  SLA     C
        SLA     C
        SLA     C
        LD      A,($4E4A)       ; read current Field Y Top again
        ADD     A,C
        CP      $59
        JP      C,L20D0         ; to GameLoop if not done, else ...
; This occurs when a game is over.
L237B:  SYSSUK  STRDIS          ; UPI STRing DISplay "GAME"
        DB      $32             ; ... X = 50
        DB      $19             ; ... Y = 25
        DB      $6C             ; ... Options = 108 (2x X-OR Write in Color 3)
        DW      L2694           ; ... String Address = 9876
        ;
        EI
        SYSSUK  STRDIS          ; UPI STRing DISplay "OVER"
        DB      $32             ; ... X = 50
        DB      $2A             ; ... Y = 42
        DB      $6C             ; ... Options = 108 (2x X-OR Write in Color 3)
        DW      L2699           ; ... String Address = 9881
        ;
        SYSSUK  PAWS            ; UPI PAUSE for 3 seconds
        DB      $B4             ; ... Interrupts = 180
; when the trigger is pulled then the game jumps to the beginning of the
; On-Board ROM and starts again.  
L238D:  IN      A,(SW0)         ; inport =&(16) for HANDLE #1
        BIT     4,A
        JR      Z,L238D                 ; (-$06)
        JP      SYSROM          ; JumP to 0 to RESET System
; could have saved one byte using SYSTEM QUIT ; cartridge execution !!

; Draw Invader's Shot [#1, 2, or 3] and Check for Collision routine
L2396:  CALL    L24A3           ; do DRAW Invader's SHOT #[??]
        IN      A,(INTST)       ; inport =&(8) to CHECK INTercept STatus 
        OR      A
        RET     Z               ; done if No collision
        CALL    L24A3           ; do ERASE Invader's SHOT ?? 
        LD      (IX+$01),A      ; save ?? as VBSTATus byte
; Collision ?? Invader's Shot #4 finishes here ??
        LD      E,(IX+$06)      ; read VBXH for X Location
        LD      D,(IX+$0B)      ; read VBYH for Y Location
        XOR     A               ; Color 0 Mask to Write Rectangle with
        LD      B,$06           ; Y-Size of Rectangle (6 Pixels)
        LD      C,$04           ; X-Size of Rectangle (4 Pixels)
        SYSTEM  RECTAN          ; UPI paint a RECTANgle
        ;
        LD      A,(IX+$0B)      ; read VBYH for Y Location
        CP      $50               
        RET     C               ; if above 80 a Bunker was hit
        LD      A,($4E44)       ; read Player X Position
        LD      E,A
        LD      A,(IX+$06)      ; read VBXH for X Location
        SUB     E
        DEC     A
        CP      $08
        RET     NC              ; RETurn if ??
        POP     HL              ; eat Return Address and continue...
        JP      L2429           ; to ??

; show POINTS value
L23C6:  SYSSUK  DISNUM          ; UPI DISplay NUMber [PLOP Write]
        DB      $7C             ; ... X = 124 (Character Position 17)
        DB      $00             ; ... Y = 0 (Top of Screen)
        DB      $0C             ; ... Options = 12
        DB      $84             ; ... Extended = 132 (Suppress Leading Zero
                                ;       and Display 4 Digits)
        DW      $4E5F           ; ... Number Address = 20063 for SCORE 
        ;
        RET

; MAYBE Launch UFO routine
L23CF:  LD      A,($4E5D)       ; read UFO Delta X
        OR      A
        JR      NZ,L23F9                ; (+$24) if already in Motion
        LD      A,$FA
        SYSTEM  RANGED          ; UPI RANGED random number 0 to 250 
        ;
        CP      $03
        RET     NZ
        SYSTEM  RANGED          ; UPI RANGED random number 0 to 2
        ;
        CP      $01             ; [only start Once in 251 x 3 calls]
        RET     NZ
        LD      A,($4E53)       ; read Invader Delta X [+1 or -1]
        NEG
        LD      ($4E5D),A       ; write -Delta X to UFO Delta X
        OR      A
        JP      M,L23F4         ; if negative [moving Left] Delta
        LD      A,$00           ; else [Right] write 0 to UFO X Position
        LD      ($4E5E),A
        JR      L23F9                   ; (+$05)

L23F4:  LD      A,$96           ; write 150 to UFO X Position
        LD      ($4E5E),A
; move then Draw UFO (or Erase if at limits)
L23F9:  LD      A,($4E5D)       ; read UFO Delta X
        LD      C,A
        LD      A,($4E5E)
        ADD     A,C             ; add to UFO X Position
        LD      ($4E5E),A
        OR      A
        JR      Z,L241D                 ; (+$16) to Erase UFO if at Left edge
        CP      $97
        JR      Z,L241D                 ; (+$12) to Erase UFO if at Right edge
        LD      E,A             ; X Coordinate
        LD      D,$09           ; Y Coordinate
        LD      A,$00           ; Magic Register to PLOP
        LD      HL,L271F        ; point at 16 by 4 UFO Saucer pattern
        SYSTEM  WRITP           ; UPI WRITe with Pattern size lookup
        ;
; play two notes for UFO Moves on-screen then MusicQUIeT
        SYSSUK  BMUSIC          ; UPI Begin playing MUSIC
        DW      $4F12           ; ... Music Stack = 20242
        DB      $C0             ; ... Voices = 192
        DW      L264D           ; ... Score Address = 9805
        ;
        RET

; Erase UFO subroutine
L241D:  XOR     A
        LD      ($4E5D),A       ; write 0 to UFO Delta X
        SYSSUK  RECTAN          ; UPI paint a RECTANgle
        DB      $00             ; ... X = 0
        DB      $09             ; ... Y = 9
        DB      $9F             ; ... Width = 159
        DB      $06             ; ... Height = 6
        DB      $00             ; ... Color = 0
        ;
        RET

; ...continued ??
L2429:  CALL    L254D           ; do Explosion routine
        LD      A,($4E44)
        LD      ($4E46),A       ; write PLAYER X to Invader Explosion X position
        LD      A,$54
        LD      ($4E47),A       ; write 84 to Invader Explosion Y position
        LD      A,$28    
        LD      ($4E45),A       ; write 40 to Base Explosion counter
        LD      A,$00
        LD      ($4E11),A       ; write 0 to clear Player's VBSACTive bit
L2441:  CALL    L254D           ; do Explosion routine again
        LD      B,$02
        SYSTEM  PAWS            ; UPI PAUSE 1/30th second
        ;
        LD      A,($4E45)       ; read Base Explosion counter again
        OR      A
        JR      Z,L2450                 ; (+$02) when counted down
        JR      L2441                   ; (-$0f) else loop

; stop Sounds, blank Explosion at Bottom of Screen then ??
L2450:  SYSTEM  EMUSIC          ; UPI End playing MUSIC
        ;
        SYSSUK  RECTAN          ; UPI paint a RECTANgle
        DB      $00             ; ... X = 0
        DB      $4F             ; ... Y = 79
        DB      $9F             ; ... Width = 159
        DB      $0B             ; ... Height = 11
        DB      $00             ; ... Color = 0
        ;
        LD      A,$08           ; write 8 to Player X Position
        LD      ($4E44),A
        LD      A,($4E62)       ; Load ACCUM with Number of Bases
        DEC     A               ; Decrease Extra Bases by 1
        LD      ($4E62),A       ; A Player's Base has been Destroyed
        CALL    L246B           ; do Display "BASES" and bases left on screen
        JP      L20D0           ; to continue ??

; display Bases Left in the top-left corner 
L246B:  SYSSUK  DISNUM          ; UPI DISplay NUMber [PLOP Write]
        DB      $30             ; ... X = 48 (Character Position 7)
        DB      $00             ; ... Y = 0 (Top of Screen)
        DB      $0C             ; ... Options = 12 ("On Color" = 3, "Off Color" = 0)
        DB      $82             ; ... Extended = 130 (Suppress Leading Zero
                                ;       and Display 2 Digits)
        DW      $4E62           ; ... Number Address = 20066 "Lives"
        ;
        RET

; play HeartBeep and set Delay routine
L2474:  LD      A,(CT3)         ; read $4FD8 for Counter/Timer #3
        OR      A
        RET     NZ              ; bail if CT3 not counted down
        LD      IX,$4F12        ; point at MusicSTACKtop !!
        LD      A,$0C           ; preset VOICE Mask to NOTE C only !!
        LD      HL,L269E        ; point at HeartBeep musicSCORE !!
        SYSTEM  BMUSIC          ; UPI Begin playing MUSIC
        ;
        LD      A,$80
        LD      ($4E5C),A       ; save 128 to HeartBeep DELAY byte
        RET

; Reverse Direction and Drop Invaders [by 2 pixels] routine
L248A:  LD      A,($4E53)       ; read Invader Delta X
        NEG
        LD      ($4E53),A       ; write -Delta X
        LD      A,($4E4A)       ; old Field Y Top + 2 for new Y Top
        INC     A
        INC     A
        LD      ($4E4A),A
        RET

; draw a Player's BULLET by Vector Block 
L249B:  LD      IX,$4E10        ; point at Player's Shot Vector Block
        LD      (IX+$00),$20    ; set VBMR for X-OR writes
; draw an Invader's BULLET entry point 
L24A3:  BIT     VBSACT,(IX+$01)
        RET     Z               ; bail if NOT VBStatus ACTive bit
        LD      HL,L2705        ; point at SHOT Pattern
        SYSTEM  VWRITR          ; UPI Vector WRITe Relative
        ;
        RET

; erase Player's OLD Shot by Vector Block 
L24AE:  LD      IX,$4E10        ; point at Player's Shot Vector Block
        BIT     VBSACT,(IX+$01)
        RET     Z               ; bail if NOT VBStatus ACTive bit
        LD      D,(IX+$0B)      ; read VB Y High - 1 for UL Corner of Rectangle
        DEC     D
        LD      E,(IX+$06)      ; read VB X High for UL Corner of Rectangle
        LD      B,$06           ; monocrome 8 x 6 BLANK
        LD      C,$01
        LD      A,$00
        SYSTEM  RECTAN          ; UPI paint a RECTANgle
        ;
        RET

; ?? routine
L24C7:  PUSH    HL              ; store the Invader Delay A, B, or C pointer
        IN      A,(INTST)       ; inport =&(8) to CLEAR ?? INTercept STatus [why??]
        LD      A,(IX+$01)      ; read Vector Block STATus
        BIT     VBSACT,A
        JP      NZ,L2532        ; skip if already VBStatus ACTive bit
        LD      A,(HL)          ; read Invader's Delay value ??
        OR      A
        JP      NZ,L2532        ; skip if moving ??
        LD      A,$08
        SYSTEM  RANGED          ; UPI RANGED random number 0 to 7
        ;
        LD      B,A
        LD      C,$80
L24DE:  OR      A
        JR      Z,L24E6                 ; (+$05)
        DEC     A
        SRL     C
        JR      L24DE                   ; (-$08)

L24E6:  LD      A,($4E58)       ; read Invader's Footprint
        LD      D,A
L24EA:  LD      A,D
        AND     C
        JR      NZ,L24F2                ; (+$04)
        RLC     C
        JR      L24EA                   ; (-$08)

L24F2:  LD      A,$3C           ; write 60 as ??
        LD      (HL),A
        LD      (IX+$01),$80    ; set VBStatus ACTive bit only
        LD      A,($4E4A)       ; read current Field Y Top
        ADD     A,$21
        LD      H,A
        LD      IY,$4E4F        ; point at Live Invaders array
        LD      A,C
        LD      E,$00
        AND     (IY+$03)        ; ?? in Bottom Row...
        JR      NZ,L251D                ; (+$12)
        LD      E,$08
        LD      A,C
        AND     (IY+$02)        ; ...or...
        JR      NZ,L251D                ; (+$0a)
        LD      E,$10
        LD      A,C
        AND     (IY+$01)        ; ...or...
        JR      NZ,L251D                ; (+$02)
        LD      E,$18           ; ...must be Top Row
L251D:  LD      A,H
        SUB     E
        LD      (IX+$0B),A      ; save as Vector Block Y High
        LD      A,($4E49)       ; read Field X Left
; loop on 8 bits of ??
L2525:  BIT     7,C
        JR      NZ,L252F                ; (+$06)
        SLA     C
        ADD     A,$10
        JR      L2525                   ; (-$0a)

L252F:  LD      (IX+$06),A      ; save as Vector Block X High
; skip to here on ??
L2532:  LD      HL,L27DF        ; Limit Table #2 for Invader's Shot
        SYSTEM  VECT            ; UPI VECTor move coordinate pair
        ;
        LD      (IX+$02),$01    ; set VBTIMB for single step
        POP     HL              ; restore the Invader Delay pointer
        INC     HL              ; plus 1 ??
        BIT     VBCLAT,(IX+$0C) ; VB Y Check, coordinate Limit ATtained ?
        RET     Z               ; bail if NOT
; else hit Bottom of the screen
        LD      A,$00
        LD      (IX+$01),$00    ; clear whole VBSTATus byte ??
        LD      (IX+$0B),$00    ; clear Vector Block Y High
        RET

; Explode a Invader or Bunker (or Player Base) routine
L254D:  LD      A,($4E45)       ; read Invader Explosion counter
        OR      A
        RET     Z               ; bail if NOT Exploding
        DEC     A
        LD      ($4E45),A       ; bump down Explosion counter
        JR      Z,L257A                 ; (+$22) to Blank if now 0
        LD      HL,L270E        ; point at Invader EXPLOSION Pattern 
        LD      DE,($4E46)      ; Explosion X, Y Coordinate
        LD      A,$20           ; Magic Register for X-OR
        SYSTEM  WRITR           ; UPI WRITe RELATIVE [On, then Off]
        ;
        LD      A,($4E46)       ; check for Player Base is Exploding ?
        LD      E,A
        LD      A,($4E44)
        CP      E
        JR      Z,L2576                 ; (+$09) to Play GUNSHOT and RETurn
        LD      A,($4E1B)       ; ... else no, if Below SCORE ?
        CP      $0C
        CALL    NC,L260B        ; do PLAY Invader (or Bunker) EXPLODES
        RET

; play SHOT FIRED repeatedly for Player EXPLOSION
L2576:  CALL    GUNSHOT         ; do ON-BOARD Play GUNSHOT
        RET

; Blank Invader Explosion
L257A:  LD      DE,($4E46)      ; read word Explosion XY position
        LD      C,$09           ; Width/Height = 6 x 9
        LD      B,$06
        XOR     A
        SYSTEM  RECTAN          ; UPI paint a RECTANgle
        ;
        RET

; draw a Row of INVADERs by VECTOR BLOCK ??
; ----------------------
;   This routine draws one row of Invaders.
L2586:  EXX                     ; Exchange Alternate Registers
        LD      A,($4E4D)       ; limit [Which Row] to 0 through 3
        CP      $04
        JR      C,L2593                 ; (+$05)
        LD      A,$00
        LD      ($4E4D),A       ; clear [Which Row] if 4 or more
L2593:  LD      HL,$4E4F        ; point at first of 4 $FFs [32 Bits for 32 Invaders]
        LD      E,A
        LD      D,$00
        ADD     HL,DE           ; add 0-3 for $4E4F thru $4E52 [8 Bits for 8 Invaders]
        LD      B,(HL)
        LD      IX,$4E49
        LD      A,(IX+$01)      ; read $4E4A ?? current Field Y Top
        SLA     E               ; 0-3 times 8
        SLA     E
        SLA     E
        ADD     A,E             ; Field Top plus ??
        LD      (IX+$03),A      ; save as $4E4C ?? current Row Y Top
        LD      (IX+$05),$00    ; clear $4E4E ??
; loop for ??
L25B0:  BIT     7,B             ; test ??
        JR      Z,L25FF                 ; (+$4b) break if ??
        LD      IY,L2678        ; index IY to 'Invader patterns by Row' table
        LD      D,$00
        LD      E,(IX+$04)      ; read $4E4D ?? [Which Row 0-3 from the top??]
        SLA     E               ; times 4
        SLA     E
        LD      A,($4E49)       ; read Field X Left
        AND     $02             ; mask 00000010B for ?? Alternate Invader pattern
        ADD     A,E             ; ?? plus Row x 4
        LD      E,A
        ADD     IY,DE           ; add ?? offset to get ...
        LD      L,(IY+$00)      ; Pattern Address for WRITP
        LD      H,(IY+$01)      
        LD      E,(IX+$00)      ; Field X Left ?? again ??
        LD      A,(IX+$05)      ; read $4E4E ??
        SLA     A               ; ?? times 16
        SLA     A
        SLA     A
        SLA     A
        ADD     A,E             ; plus ??
        LD      E,A             ; X Coordinate for WRITP
        LD      D,(IX+$03)      ; $4E4C ?? Y Coordinate for WRITP
        LD      A,$00           ; Magic Register for WRITP
        PUSH    IX
        PUSH    BC
        SYSTEM  WRITP           ; UPI WRITe with Pattern size lookup
        ;
        LD      A,($4E65)      ; Read GAMe DIFficulty
        LD      B,$FF           ; Default Delay
        CP      $02
        JR      C,L25F9                 ; (+$06) if Amateur or Novice
        JR      Z,L25F7                 ; (+$02) if Imtermediate [medium Delay]
        JR      L25FC                   ; (+$05) else Professional [no Delay]

L25F7:  LD      B,$64
L25F9:  NOP                     ; delay Loop by Difficulty
        DJNZ    L25F9                   ; (-$03) 
L25FC:  POP     BC
        POP     IX
; to next Invader bit
L25FF:  INC     (IX+$05)        ; $4E4E ?? [for right edge ??]
        SLA     B
        JR      NZ,L25B0                ; (-$56) while Invaders remain in Row
        INC     (IX+$04)        ; $4E4D ?? [for Next Row to draw ??]
        EXX                     ; Exchange Alternate Registers
        RET

; play Invader (or Bunker) EXPLODES sound
L260B:  LD      A,(CT3)         ; read $4FD8 for Counter/Timer #3
        OR      A
        RET     NZ              ; bail if CT3 not counted down
        SYSSUK  BMUSIC          ; UPI Begin playing MUSIC
        DW      $4F12           ; ... Music Stack = 20242
        DB      $5C             ; ... Voices = 92
        DW      L261D           ; ... Score Address = 9757
        ;
        LD      A,$19
        LD      (CT3),A         ; save 25 in Counter/Timer #3
        RET

; Invader (or Bunker) EXPLOSION Music Score
L261D:  MASTER  $35
        VOLUME  $AA,$0A         ; VA = 10, VB = 10, VC= 10, NM = 0
        NOTE1   $01,CS5
        VOLUME  $EE,$0E         ; VA = 14, VB = 14, VC= 14, NM = 0
        NOTE1   $01,$1E
        VOLUME  $DD,$0D         ; VA = 13, VB = 13, VC= 13, NM = 0
        NOTE1   $01,$19
        VOLUME  $BB,$0B         ; VA = 11, VB = 11, VC= 11, NM = 0
        NOTE1   $01, D4
        VOLUME  $99,$09         ; VA = 9, VB = 9, VC= 9, NM = 0
        NOTE1   $01, G4
        VOLUME  $77,$07         ; VA = 7, VB = 7, VC= 7, NM = 0
        NOTE1   $01,CS5
        VOLUME  $55,$05         ; VA = 5, VB = 5, VC= 5, NM = 0
        NOTE1   $01, G5
        VOLUME  $33,$03         ; VA = 3, VB = 3, VC= 3, NM = 0
        NOTE1   $01,DS6
        VOLUME  $11,$01         ; VA = 1, VB = 1, VC= 1, NM = 0
        NOTE1   $03, G7
        QUIET

; UFO Moving only sucks Tone A ?? Tone B keeps as last played Note !! Tone C is muted !!
L264D:  MASTER  $14
        VOLUME  $FF,$00         ; VA = 15, VB = 15, VC= 0, NM = 0
        NOTE1   $03, A4
        NOTE1   $03, D4
        QUIET

; Player takes a SHOT with VIBRAto
L2657:  SYSSUK  BMUSIC          ; UPI Begin playing MUSIC
        DW      $4F12           ; ... Music Stack = 20242
        DB      $C0             ; ... Voices = 192
        DW      L265F           ; ... Score Address = 9823
        ;
        RET

; Player SHOOTS Music Score
L265F:  MASTER  $28
        OUTPUT  $04,$14         ; set VIBRAto = 20 for ??
        VOLUME  $FF,$00         ; VA = 15, VB = 15, VC= 0, NM = 0
        NOTE1   $01, C6
        VOLUME  $AA,$00         ; VA = 10, VB = 10, VC= 0, NM = 0
        NOTE1   $01, F5
        VOLUME  $77,$00         ; VA = 7, VB = 7, VC= 0, NM = 0
        NOTE1   $01,$0C
        VOLUME  $55,$00         ; VA = 5, VB = 5, VC= 0, NM = 0
        NOTE1   $09, D4
        QUIET

; 8-word "Invader Pattern pairs for 4 Rows" Table
L2678:  DW      L2731           ; Red Invader (Top Row) pattern address
        DW      L274E           ; Red Invader (Alt. Version) ditto...
        DW      L276B           ; Green Invader (Top-Middle Row)
        DW      L2788           ; Green Invader (Alt. Version)
        DW      L27A5           ; "Blue" Invader - Second-from-Bottom Row
        DW      L27C2           ; "Blue" Invader - Second-from-Bottom Row (Alt. Version)
        DW      L27C2           ; "Blue" Invader - Bottom-Row Invader [again but swapped]
        DW      L27A5           ; "Blue" Invader - Bottom-Row Invader (Alt. Version)

; LIVES Text string
L2688:  DB      "BASES",$00

; POINTS Text string
L268E:  DB      "SCORE",$00

; FINISHED Text string(s)
L2694:  DB      "GAME",$00
L2699:  DB      "OVER",$00

; HEART-BEEP Music Score (when Invaders move ??)
L269E:  MASTER  $A1
        VOLUME  $00,$0C         ; VA = 0, VB = 0, VC= 12, NM = 0
        NOTE1   $06,$30
        NOTE1   $06,$50
        NOTE1   $06, A1
        NOTE1   $06,$7F
        QUIET

; Player BASE 3 Bytes by 6 Rows (note: ALL are 4-color) Pattern
L26AC:  DB      $00,$C0,$00     ; . . . . 3 . . . . . . .
        DB      $00,$C0,$00     ; . . . . 3 . . . . . . .
        DB      $03,$F0,$00     ; . . . 3 3 3 . . . . . .
        DB      $0F,$FC,$00     ; . . 3 3 3 3 3 . . . . .
        DB      $0F,$FC,$00     ; . . 3 3 3 3 3 . . . . .
        DB      $0F,$FC,$00     ; . . 3 3 3 3 3 . . . . .

; Player's BUNKER color Pattern
L26BE:  DB      $05             ; WIDTH = 5 Bytes
        DB      $0D             ; HEIGHT = 13 Rows
        ;
        DB      $03,$FF,$FF,$FF,$C0 ; . . . 3 3 3 3 3 3 3 3 3 3 3 3 3 3 . . .
        DB      $0F,$FF,$FF,$FF,$F0 ; . . 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 . .
        DB      $3F,$FF,$FF,$FF,$FC ; . 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 .
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$FF,$FF,$FF,$FF ; 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3
        DB      $FF,$F0,$00,$0F,$FF ; 3 3 3 3 3 3 . . . . . . . . 3 3 3 3 3 3
        DB      $FF,$C0,$00,$03,$FF ; 3 3 3 3 3 . . . . . . . . . . 3 3 3 3 3
        DB      $FF,$00,$00,$00,$FF ; 3 3 3 3 . . . . . . . . . . . . 3 3 3 3
        DB      $FF,$00,$00,$00,$FF ; 3 3 3 3 . . . . . . . . . . . . 3 3 3 3

; ?? vectorLIMIT Table #1 for Player's Shot
L2701:  DB      $0A             ; X Lower Limit (Left Edge of Screen + 10)
        DB      $A0             ; X Upper Limit (Right Edge of Screen)
        DB      $09             ; Y Lower Limit (Right Below the Score)
        DB      $5A             ; Y Upper Limit (Bottom of Screen)

; Player's (and Invader's) SHOT (for VWRITR) Pattern
L2705:  DB      $00             ; X Displacement = 0
        DB      $00             ; Y Displacement = 0
        DB      $01             ; WIDTH = 1 Byte
        DB      $05             ; HEIGHT = 5 Rows
        ;
        DB      $00             ; . . . .
        DB      $C0             ; 3 . . .
        DB      $C0             ; 3 . . .
        DB      $C0             ; 3 . . .
        DB      $C0             ; 3 . . .

; Invader EXPLOSION (for WRITR) Pattern
L270E:  DB      $00             ; X Displacement = 0
        DB      $00             ; Y Displacement = 0
        DB      $02             ; WIDTH = 2 Bytes
        DB      $06             ; HEIGHT = 6 Rows
        ;
        DB      $30,$0C         ; . 3 . . . . 3 .
        DB      $3C,$0C         ; . 3 3 . . . 3 .
        DB      $37,$C7         ; . 3 1 3 3 . 1 3
        DB      $F5,$57         ; 3 3 1 1 1 1 1 3
        DB      $3F,$FC         ; . 3 3 3 3 3 3 .
        DB      $CF,$FF         ; 3 . 3 3 3 3 3 3

        DB      $FC             ; stray -4 X Displacement ??

; UFO 4 Bytes by 4 Rows color Pattern
L271F:  DB      $04             ; WIDTH = 4 Bytes
        DB      $04             ; HEIGHT = 4 Rows
        ;
        DB      $00,$2A,$A0,$00 ; . . . . . 2 2 2 2 2 . . . . . .
        DB      $02,$AA,$AA,$00 ; . . . 2 2 2 2 2 2 2 2 2 . . . .
        DB      $28,$88,$88,$A0 ; . 2 2 . 2 . 2 . 2 . 2 . 2 2 . .
        DB      $0A,$AA,$AA,$80 ; . . 2 2 2 2 2 2 2 2 2 2 2 . . .

; ALIENS all 3 Bytes by 9 Rows color Patterns
; (Standard) RED Invader (Top Row)
; Uses Colors 0-2 (Right side of Horizontal Color Boundary)
;        COL0R - Blank (Background as '.'x)
;        COL1R - Blue (Invader's Eyes)
;        COL2R - Red (Invader's Body)
L2731:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$82,$00     ; . . . . 2 . . 2 . . . .
        DB      $08,$28,$20     ; . . 2 . . 2 2 . . 2 . .
        DB      $0A,$AA,$A0     ; . . 2 2 2 2 2 2 2 2 . .
        DB      $0A,$69,$A0     ; . . 2 2 1 2 2 1 2 2 . .
        DB      $00,$82,$00     ; . . . . 2 . . 2 . . . .
        DB      $00,$28,$00     ; . . . . . 2 2 . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .

; (Alternate) RED Invader
L274E:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$82,$00     ; . . . . 2 . . 2 . . . .
        DB      $00,$28,$00     ; . . . . . 2 2 . . . . .
        DB      $02,$AA,$80     ; . . . 2 2 2 2 2 2 . . .
        DB      $0A,$69,$A0     ; . . 2 2 1 2 2 1 2 2 . .
        DB      $08,$82,$20     ; . . 2 . 2 . . 2 . 2 . .
        DB      $00,$82,$00     ; . . . . 2 . . 2 . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .

; (Standard) GREEN Invader (Top-Middle Row)
; Uses Colors 0-2 (Right side of Horizontal Color Boundary)
;        COL0R - Blank (Background as '.'x)
;        COL1R - Green (Invader's Body)
;        COL2R - Red (Invader's Eyes)
L276B:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $01,$00,$40     ; . . . 1 . . . . 1 . . .
        DB      $00,$55,$00     ; . . . . 1 1 1 1 . . . .
        DB      $01,$96,$40     ; . . . 1 2 1 1 2 1 . . .
        DB      $05,$55,$50     ; . . 1 1 1 1 1 1 1 1 . .
        DB      $10,$55,$04     ; . 1 . . 1 1 1 1 . . 1 .
        DB      $10,$00,$04     ; . 1 . . . . . . . . 1 .
        DB      $05,$00,$50     ; . . 1 1 . . . . 1 1 . .

; ((Alternate) GREEN Invader
L2788:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$41,$00     ; . . . . 1 . . 1 . . . .
        DB      $00,$55,$00     ; . . . . 1 1 1 1 . . . .
        DB      $01,$96,$40     ; . . . 1 2 1 1 2 1 . . .
        DB      $05,$55,$50     ; . . 1 1 1 1 1 1 1 1 . .
        DB      $10,$55,$04     ; . 1 . . 1 1 1 1 . . 1 .
        DB      $10,$00,$04     ; . 1 . . . . . . . . 1 .
        DB      $10,$00,$04     ; . 1 . . . . . . . . 1 .

; (Standard) "BLUE" Invader [really still DARK Green !!]
L27A5:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$14,$00     ; . . . . . 1 1 . . . . .
        DB      $10,$55,$04     ; . 1 . . 1 1 1 1 . . 1 .
        DB      $11,$55,$44     ; . 1 . 1 1 1 1 1 1 . 1 .
        DB      $15,$96,$54     ; . 1 1 1 2 1 1 2 1 1 1 .
        DB      $00,$55,$00     ; . . . . 1 1 1 1 . . . .
        DB      $00,$41,$00     ; . . . . 1 . . 1 . . . .
        DB      $01,$00,$40     ; . . . 1 . . . . 1 . . .

; (Alternate) "BLUE" Invader
L27C2:  DB      $03             ; WIDTH = 3 Bytes
        DB      $09             ; HEIGHT = 9 Rows
        ;
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$00,$00     ; . . . . . . . . . . . .
        DB      $00,$14,$00     ; . . . . . 1 1 . . . . .
        DB      $00,$55,$00     ; . . . . 1 1 1 1 . . . .
        DB      $01,$55,$40     ; . . . 1 1 1 1 1 1 . . .
        DB      $15,$96,$54     ; . 1 1 1 2 1 1 2 1 1 1 .
        DB      $10,$55,$04     ; . 1 . . 1 1 1 1 . . 1 .
        DB      $10,$69,$04     ; . 1 . . 1 2 2 1 . . 1 .
        DB      $04,$14,$10     ; . . 1 . . 1 1 . . 1 . .

; ?? vectorLIMIT Table #2 for Invader's Shot
L27DF:  DB      $00             ; X Lower Limit (Left Edge of Screen)
        DB      $A0             ; X Upper Limit (Right Edge of Screen)
        DB      $00             ; Y Lower Limit (Top of Screen)
        DB      $55             ; Y Upper Limit (Right Above the Player's Ship)

; GAME TITLE Text string
L27E3:  DB      "SPACE",$20,"INVADERS",$00

; 8 Bytes COLor TABle
; Left side not used since the Horizontal Color Boundary is at 0
L27F2:  DB      $22             ; COL3L - Purple
        DB      $64             ; COL2L - Orange
        DB      $74             ; COL1L - Yellow
        DB      $07             ; COL0L - WHITE
; Right side of Horizontal Color Boundary
        DB      $22             ; COL3R - Purple (Text, Bunkers, Gun and Shots)
        DB      $64             ; COL2R - Red (Invaders, U.F.O. and Border)
        DB      $C8             ; COL1R - DARK Green (Invaders)
        DB      $07             ; COL0R - WHITE (Background)

; DIFFICULTY Text string (to END !!)
L27FA:  DB      "LEVEL",$00

        END
